<html>
<head>
<title>Ogre::GLSLESProgramPipeline Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1GLSLESProgramPipeline.html">GLSLESProgramPipeline</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-types">Protected Types</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::GLSLESProgramPipeline Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::GLSLESProgramPipeline" --><!-- doxytag: inherits="Ogre::GLSLESProgramCommon" -->
<p>Specialisation of <a class="el" href="classOgre_1_1HighLevelGpuProgram.html" title="Abstract base class representing a high-level program (a vertex or fragment program).">HighLevelGpuProgram</a> to provide support for OpenGL Shader Language (GLSL ES) for OpenGL ES 2.0.  
 <a href="classOgre_1_1GLSLESProgramPipeline.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreGLSLESProgramPipeline_8h_source.html">OgreGLSLESProgramPipeline.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::GLSLESProgramPipeline:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1GLSLESProgramPipeline__inherit__graph.gif" border="0" usemap="#Ogre_1_1GLSLESProgramPipeline_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1GLSLESProgramPipeline_inherit__map" id="Ogre_1_1GLSLESProgramPipeline_inherit__map">
<area shape="rect" id="node2" href="classOgre_1_1GLSLESProgramCommon.html" title="C++ encapsulation of GLSL ES Program Object." alt="" coords="5,5,216,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1GLSLESProgramPipeline-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#a2de16880e0dedda46c752c782bf0bec9">GLSLESProgramPipeline</a> (<a class="el" href="classOgre_1_1GLSLESGpuProgram.html">GLSLESGpuProgram</a> *vertexProgram, <a class="el" href="classOgre_1_1GLSLESGpuProgram.html">GLSLESGpuProgram</a> *fragmentProgram)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor should only be used by <a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html" title="Ogre assumes that there are separate vertex and fragment programs to deal with but GLSL ES has one pr...">GLSLESProgramPipelineManager</a>.  <a href="#a2de16880e0dedda46c752c782bf0bec9"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#ae20aca570ff72e3b8ed3e7c926ad5558">~GLSLESProgramPipeline</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">GLuint&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#a4bee8edfdf5d9e9b8be49ade42b34bd6">getGLProgramPipelineHandle</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">GL Program Pipeline Handle.  <a href="#a4bee8edfdf5d9e9b8be49ade42b34bd6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#aea14577f15c1ef4d81921d0455983b43">updateUniforms</a> (<a class="el" href="group__Materials.html#gaebab7cecf3f3ae81a1fbfa08ab36f2b5">GpuProgramParametersSharedPtr</a> params, <a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> mask, <a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a> fromProgType)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Updates program pipeline object uniforms using data from <a class="el" href="classOgre_1_1GpuProgramParameters.html" title="Collects together the program parameters used for a GpuProgram.">GpuProgramParameters</a>.  <a href="#aea14577f15c1ef4d81921d0455983b43"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#aec8e2b4cc8d39950abeaec2a5187fd51">updatePassIterationUniforms</a> (<a class="el" href="group__Materials.html#gaebab7cecf3f3ae81a1fbfa08ab36f2b5">GpuProgramParametersSharedPtr</a> params)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Updates program pipeline object uniforms using data from pass iteration <a class="el" href="classOgre_1_1GpuProgramParameters.html" title="Collects together the program parameters used for a GpuProgram.">GpuProgramParameters</a>.  <a href="#aec8e2b4cc8d39950abeaec2a5187fd51"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#aa2bbf63617d7c69b0d7bd23c1c64cc64">activate</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Makes a program pipeline object active by making sure it is linked and then putting it in use.  <a href="#aa2bbf63617d7c69b0d7bd23c1c64cc64"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual GLint&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#a8676a1c75ed9764bd50ee1c766bbcc51">getAttributeIndex</a> (<a class="el" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a> semantic, <a class="el" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> index)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the index of a non-standard attribute bound in the linked code.  <a href="#a8676a1c75ed9764bd50ee1c766bbcc51"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">GLuint&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramCommon.html#af0d73a3352f3d0d396fa5ced1cb7c79e">getGLProgramHandle</a> (void) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the GL Handle for the program object.  <a href="#af0d73a3352f3d0d396fa5ced1cb7c79e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramCommon.html#a67993567b5302107ef1730147aa4071b">setSkeletalAnimationIncluded</a> (bool included)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets whether the linked program includes the required instructions to perform skeletal animation.  <a href="#a67993567b5302107ef1730147aa4071b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramCommon.html#a8cf3062bfbf1c8a7ba0c2ff3350cbfae">isSkeletalAnimationIncluded</a> (void) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns whether the linked program includes the required instructions to perform skeletal animation.  <a href="#a8cf3062bfbf1c8a7ba0c2ff3350cbfae"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramCommon.html#a073a89b01f4272838b0fd55a0c7695b6">isAttributeValid</a> (<a class="el" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a> semantic, <a class="el" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> index)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Is a non-standard attribute bound in the linked code?  <a href="#a073a89b01f4272838b0fd55a0c7695b6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1GLSLESGpuProgram.html">GLSLESGpuProgram</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramCommon.html#a5d44237c5eb6e0d27f26c4ddae941992">getVertexProgram</a> (void) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1GLSLESGpuProgram.html">GLSLESGpuProgram</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramCommon.html#a02bc60d115a5ca95f53573aaf0c4dc81">getFragmentProgram</a> (void) const </td></tr>
<tr><td colspan="2"><h2><a name="pro-types"></a>
Protected Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom">{ <a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#ab776de6332a02d5dca0d26e4109b1d9da218db445442e15ffa3b1def09d3ec939">VERTEX_PROGRAM_LINKED</a> =  0x01, 
<a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#ab776de6332a02d5dca0d26e4109b1d9dabbf6d89ca1487f29c82cc65bddd543d2">FRAGMENT_PROGRAM_LINKED</a> =  0x10, 
<a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#ab776de6332a02d5dca0d26e4109b1d9daa5b33b811cc161d428047f0d4f1d4b08">ALL_PROGRAMS_LINKED</a> =  0x11
 }</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1set.html">set</a>&lt; GLuint &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramCommon.html#a6089666bc8be948f5ebecfd598d08d05">AttributeSet</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt; <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>, <br class="typebreak"/>
<a class="el" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a> &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramCommon.html#afd8df837c19c089dd8d3de4d79195dba">SemanticToStringMap</a></td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#a6d84ad9f6e5b6b42b84fbf7185da3b80">compileAndLink</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Compiles and links the separate vertex and fragment programs.  <a href="#a6d84ad9f6e5b6b42b84fbf7185da3b80"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#a278451323a8ef731de756b2d2cef7ca9">_useProgram</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Put a program pipeline in use.  <a href="#a278451323a8ef731de756b2d2cef7ca9"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#aaafe62857a8b7996237c82ccbc0136a6">extractLayoutQualifiers</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Finds layout qualifiers in the shader source and sets attribute indices appropriately.  <a href="#aaafe62857a8b7996237c82ccbc0136a6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#af495f084ca1e8d3abf51d440c6aedfab">buildGLUniformReferences</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Build uniform references from active named uniforms.  <a href="#af495f084ca1e8d3abf51d440c6aedfab"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramCommon.html#ac9185bcf579570b9bf75e7a922eec8ed">getCombinedName</a> (void)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramCommon.html#af3f80fe5f80f4a13222c5ea7719d2c6d">getMicrocodeFromCache</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the the binary data of a program from the microcode cache.  <a href="#af3f80fe5f80f4a13222c5ea7719d2c6d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramCommon.html#aedff5f978c6ff38b6d5515f8f387e8b6">getAttributeSemanticEnum</a> (<a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> type)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramCommon.html#aa4b0faea803d25caaf976fc0266580ea">getAttributeSemanticString</a> (<a class="el" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a> semantic)</td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">GLuint&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#aa572255a6a259344816485f9a430ef5b">mGLProgramPipelineHandle</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">GL handle for pipeline object.  <a href="#aa572255a6a259344816485f9a430ef5b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#a24aca8d208dcf62fbe3bee9e759ac73d">GLUniformReferenceList</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramCommon.html#afb171f98bf9599ea856e1864e26de6ea">mGLUniformReferences</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Container of uniform references that are active in the program object.  <a href="#afb171f98bf9599ea856e1864e26de6ea"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1GLSLESGpuProgram.html">GLSLESGpuProgram</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramCommon.html#ac5cf7946fde74b57c5fceb2c24a6d60a">mVertexProgram</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Linked vertex program.  <a href="#ac5cf7946fde74b57c5fceb2c24a6d60a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1GLSLESGpuProgram.html">GLSLESGpuProgram</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramCommon.html#aef417ccb07b8bad6b898ac41f54c289e">mFragmentProgram</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Linked fragment program.  <a href="#aef417ccb07b8bad6b898ac41f54c289e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramCommon.html#a47b1e5061bc550867335014ba3188c89">mUniformRefsBuilt</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Flag to indicate that uniform references have already been built.  <a href="#a47b1e5061bc550867335014ba3188c89"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">GLuint&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramCommon.html#a32fa510f466594b7bd69de3af522f793">mGLProgramHandle</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">GL handle for the program object.  <a href="#a32fa510f466594b7bd69de3af522f793"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">GLint&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramCommon.html#aa4613eadde3f6f512a89e991888ccf04">mLinked</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Flag indicating that the program or pipeline object has been successfully linked.  <a href="#aa4613eadde3f6f512a89e991888ccf04"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramCommon.html#a2e72c24016de1d9a5a361cc415094a56">mTriedToLinkAndFailed</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Flag indicating that the program or pipeline object has tried to link and failed.  <a href="#a2e72c24016de1d9a5a361cc415094a56"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramCommon.html#a4f7674420fd6fd2003a8d38260b2dd4e">mSkeletalAnimation</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Flag indicating skeletal animation is being performed.  <a href="#a4f7674420fd6fd2003a8d38260b2dd4e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">GLint&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramCommon.html#afefa1d74fe3ba0d79068e0fae9dd3392">mCustomAttributesIndexes</a> [<a class="el" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00da6f167783a26ed5d1c146fbeae995af0b">VES_COUNT</a>][<a class="el" href="OgreConfig_8h.html#a73f03c4000193e826a1489b02ea50309">OGRE_MAX_TEXTURE_COORD_SETS</a>]</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">An array to hold the attributes indexes.  <a href="#afefa1d74fe3ba0d79068e0fae9dd3392"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1GLSLESProgramCommon.html#afd8df837c19c089dd8d3de4d79195dba">SemanticToStringMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramCommon.html#ae517ad6821a32dc8ad80bbae8bc12d71">mSemanticTypeMap</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Specialisation of <a class="el" href="classOgre_1_1HighLevelGpuProgram.html" title="Abstract base class representing a high-level program (a vertex or fragment program).">HighLevelGpuProgram</a> to provide support for OpenGL Shader Language (GLSL ES) for OpenGL ES 2.0. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>GLSL ES has no target assembler or entry point specification like DirectX 9 HLSL. Vertex and Fragment shaders only have one entry point called "main". When a shader is compiled, microcode is generated but can not be accessed by the application. GLSL ES also does not provide assembler low level output after compiling. The GL ES Render system assumes that the Gpu program is a GL Gpu program so <a class="el" href="classOgre_1_1GLSLESProgramPipeline.html" title="Specialisation of HighLevelGpuProgram to provide support for OpenGL Shader Language (GLSL ES) for Ope...">GLSLESProgramPipeline</a> will create a <a class="el" href="classOgre_1_1GLSLESGpuProgram.html" title="GLSL ES low level compiled shader object - this class is used to get at the linked program object and...">GLSLESGpuProgram</a> that is subclassed from <a class="el" href="classOgre_1_1GLES2GpuProgram.html" title="Generalised low-level GL program, can be applied to multiple types (eg ARB and NV)">GLES2GpuProgram</a> for the low level implementation. The GLES2Program class will create a shader and program object and compile the source but will not create a pipeline object. It's up to <a class="el" href="classOgre_1_1GLES2GpuProgram.html" title="Generalised low-level GL program, can be applied to multiple types (eg ARB and NV)">GLES2GpuProgram</a> class to request a program pipeline object to link the program object to.</dd></dl>
<dl class="note"><dt><b>Note:</b></dt><dd>GLSL ES supports multiple modular shader objects that can be attached to one program object to form a single shader. This is supported through the "attach" material script command. All the modules to be attached are listed on the same line as the attach command separated by white space. </dd></dl>

<p>Definition at line <a class="el" href="OgreGLSLESProgramPipeline_8h_source.html#l00056">56</a> of file <a class="el" href="OgreGLSLESProgramPipeline_8h_source.html">OgreGLSLESProgramPipeline.h</a>.</p>
</div><hr/><h2>Member Typedef Documentation</h2>
<a class="anchor" id="a6089666bc8be948f5ebecfd598d08d05"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::AttributeSet" ref="a6089666bc8be948f5ebecfd598d08d05" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1set.html">set</a>&lt;GLuint&gt;::type <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#a6089666bc8be948f5ebecfd598d08d05">Ogre::GLSLESProgramCommon::AttributeSet</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreGLSLESProgramCommon_8h_source.html#l00080">80</a> of file <a class="el" href="OgreGLSLESProgramCommon_8h_source.html">OgreGLSLESProgramCommon.h</a>.</p>

</div>
</div>
<a class="anchor" id="afd8df837c19c089dd8d3de4d79195dba"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::SemanticToStringMap" ref="afd8df837c19c089dd8d3de4d79195dba" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt;<a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>, <a class="el" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a>&gt;::type <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#afd8df837c19c089dd8d3de4d79195dba">Ogre::GLSLESProgramCommon::SemanticToStringMap</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreGLSLESProgramCommon_8h_source.html#l00097">97</a> of file <a class="el" href="OgreGLSLESProgramCommon_8h_source.html">OgreGLSLESProgramCommon.h</a>.</p>

</div>
</div>
<hr/><h2>Member Enumeration Documentation</h2>
<a class="anchor" id="ab776de6332a02d5dca0d26e4109b1d9d"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::@20" ref="ab776de6332a02d5dca0d26e4109b1d9d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">anonymous enum<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl><dt><b>Enumerator: </b></dt><dd><table border="0" cellspacing="2" cellpadding="0">
<tr><td valign="top"><em><a class="anchor" id="ab776de6332a02d5dca0d26e4109b1d9da218db445442e15ffa3b1def09d3ec939"></a><!-- doxytag: member="VERTEX_PROGRAM_LINKED" ref="ab776de6332a02d5dca0d26e4109b1d9da218db445442e15ffa3b1def09d3ec939" args="" -->VERTEX_PROGRAM_LINKED</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="ab776de6332a02d5dca0d26e4109b1d9dabbf6d89ca1487f29c82cc65bddd543d2"></a><!-- doxytag: member="FRAGMENT_PROGRAM_LINKED" ref="ab776de6332a02d5dca0d26e4109b1d9dabbf6d89ca1487f29c82cc65bddd543d2" args="" -->FRAGMENT_PROGRAM_LINKED</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="ab776de6332a02d5dca0d26e4109b1d9daa5b33b811cc161d428047f0d4f1d4b08"></a><!-- doxytag: member="ALL_PROGRAMS_LINKED" ref="ab776de6332a02d5dca0d26e4109b1d9daa5b33b811cc161d428047f0d4f1d4b08" args="" -->ALL_PROGRAMS_LINKED</em>&nbsp;</td><td>
</td></tr>
</table>
</dd>
</dl>

<p>Definition at line <a class="el" href="OgreGLSLESProgramPipeline_8h_source.html#l00083">83</a> of file <a class="el" href="OgreGLSLESProgramPipeline_8h_source.html">OgreGLSLESProgramPipeline.h</a>.</p>

</div>
</div>
<hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a2de16880e0dedda46c752c782bf0bec9"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::GLSLESProgramPipeline" ref="a2de16880e0dedda46c752c782bf0bec9" args="(GLSLESGpuProgram *vertexProgram, GLSLESGpuProgram *fragmentProgram)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#a2de16880e0dedda46c752c782bf0bec9">Ogre::GLSLESProgramPipeline::GLSLESProgramPipeline</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1GLSLESGpuProgram.html">GLSLESGpuProgram</a> *&#160;</td>
          <td class="paramname"><em>vertexProgram</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1GLSLESGpuProgram.html">GLSLESGpuProgram</a> *&#160;</td>
          <td class="paramname"><em>fragmentProgram</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Constructor should only be used by <a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html" title="Ogre assumes that there are separate vertex and fragment programs to deal with but GLSL ES has one pr...">GLSLESProgramPipelineManager</a>. </p>

</div>
</div>
<a class="anchor" id="ae20aca570ff72e3b8ed3e7c926ad5558"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::~GLSLESProgramPipeline" ref="ae20aca570ff72e3b8ed3e7c926ad5558" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#ae20aca570ff72e3b8ed3e7c926ad5558">Ogre::GLSLESProgramPipeline::~GLSLESProgramPipeline</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a278451323a8ef731de756b2d2cef7ca9"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::_useProgram" ref="a278451323a8ef731de756b2d2cef7ca9" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#a278451323a8ef731de756b2d2cef7ca9">Ogre::GLSLESProgramPipeline::_useProgram</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Put a program pipeline in use. </p>

<p>Implements <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#aa89206442ecd6a350f4ce39625e08601">Ogre::GLSLESProgramCommon</a>.</p>

</div>
</div>
<a class="anchor" id="aa2bbf63617d7c69b0d7bd23c1c64cc64"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::activate" ref="aa2bbf63617d7c69b0d7bd23c1c64cc64" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#aa2bbf63617d7c69b0d7bd23c1c64cc64">Ogre::GLSLESProgramPipeline::activate</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Makes a program pipeline object active by making sure it is linked and then putting it in use. </p>

<p>Implements <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#a57913a42daec7fd2e1bb09028665a37e">Ogre::GLSLESProgramCommon</a>.</p>

</div>
</div>
<a class="anchor" id="af495f084ca1e8d3abf51d440c6aedfab"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::buildGLUniformReferences" ref="af495f084ca1e8d3abf51d440c6aedfab" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#af495f084ca1e8d3abf51d440c6aedfab">Ogre::GLSLESProgramPipeline::buildGLUniformReferences</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Build uniform references from active named uniforms. </p>

<p>Reimplemented from <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#ac46798c368ac78e7137768121c6da23a">Ogre::GLSLESProgramCommon</a>.</p>

</div>
</div>
<a class="anchor" id="a6d84ad9f6e5b6b42b84fbf7185da3b80"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::compileAndLink" ref="a6d84ad9f6e5b6b42b84fbf7185da3b80" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#a6d84ad9f6e5b6b42b84fbf7185da3b80">Ogre::GLSLESProgramPipeline::compileAndLink</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Compiles and links the separate vertex and fragment programs. </p>

<p>Implements <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#a59b96b3159a5d8ebee5ddbdb3c0f1b7f">Ogre::GLSLESProgramCommon</a>.</p>

</div>
</div>
<a class="anchor" id="aaafe62857a8b7996237c82ccbc0136a6"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::extractLayoutQualifiers" ref="aaafe62857a8b7996237c82ccbc0136a6" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#aaafe62857a8b7996237c82ccbc0136a6">Ogre::GLSLESProgramPipeline::extractLayoutQualifiers</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Finds layout qualifiers in the shader source and sets attribute indices appropriately. </p>

</div>
</div>
<a class="anchor" id="a8676a1c75ed9764bd50ee1c766bbcc51"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::getAttributeIndex" ref="a8676a1c75ed9764bd50ee1c766bbcc51" args="(VertexElementSemantic semantic, uint index)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual GLint <a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#a8676a1c75ed9764bd50ee1c766bbcc51">Ogre::GLSLESProgramPipeline::getAttributeIndex</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a>&#160;</td>
          <td class="paramname"><em>semantic</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a>&#160;</td>
          <td class="paramname"><em>index</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the index of a non-standard attribute bound in the linked code. </p>

<p>Reimplemented from <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#a30cb485afc97496fc4be1351ec74b3ac">Ogre::GLSLESProgramCommon</a>.</p>

</div>
</div>
<a class="anchor" id="aedff5f978c6ff38b6d5515f8f387e8b6"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::getAttributeSemanticEnum" ref="aedff5f978c6ff38b6d5515f8f387e8b6" args="(String type)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a> <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#aedff5f978c6ff38b6d5515f8f387e8b6">Ogre::GLSLESProgramCommon::getAttributeSemanticEnum</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&#160;</td>
          <td class="paramname"><em>type</em></td><td>)</td>
          <td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="aa4b0faea803d25caaf976fc0266580ea"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::getAttributeSemanticString" ref="aa4b0faea803d25caaf976fc0266580ea" args="(VertexElementSemantic semantic)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const char* <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#aa4b0faea803d25caaf976fc0266580ea">Ogre::GLSLESProgramCommon::getAttributeSemanticString</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a>&#160;</td>
          <td class="paramname"><em>semantic</em></td><td>)</td>
          <td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ac9185bcf579570b9bf75e7a922eec8ed"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::getCombinedName" ref="ac9185bcf579570b9bf75e7a922eec8ed" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a> <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#ac9185bcf579570b9bf75e7a922eec8ed">Ogre::GLSLESProgramCommon::getCombinedName</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a02bc60d115a5ca95f53573aaf0c4dc81"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::getFragmentProgram" ref="a02bc60d115a5ca95f53573aaf0c4dc81" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GLSLESGpuProgram.html">GLSLESGpuProgram</a>* <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#a02bc60d115a5ca95f53573aaf0c4dc81">Ogre::GLSLESProgramCommon::getFragmentProgram</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreGLSLESProgramCommon_8h_source.html#l00144">144</a> of file <a class="el" href="OgreGLSLESProgramCommon_8h_source.html">OgreGLSLESProgramCommon.h</a>.</p>

</div>
</div>
<a class="anchor" id="af0d73a3352f3d0d396fa5ced1cb7c79e"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::getGLProgramHandle" ref="af0d73a3352f3d0d396fa5ced1cb7c79e" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">GLuint <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#af0d73a3352f3d0d396fa5ced1cb7c79e">Ogre::GLSLESProgramCommon::getGLProgramHandle</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the GL Handle for the program object. </p>

<p>Definition at line <a class="el" href="OgreGLSLESProgramCommon_8h_source.html#l00121">121</a> of file <a class="el" href="OgreGLSLESProgramCommon_8h_source.html">OgreGLSLESProgramCommon.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4bee8edfdf5d9e9b8be49ade42b34bd6"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::getGLProgramPipelineHandle" ref="a4bee8edfdf5d9e9b8be49ade42b34bd6" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">GLuint <a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#a4bee8edfdf5d9e9b8be49ade42b34bd6">Ogre::GLSLESProgramPipeline::getGLProgramPipelineHandle</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>GL Program Pipeline Handle. </p>

<p>Definition at line <a class="el" href="OgreGLSLESProgramPipeline_8h_source.html#l00064">64</a> of file <a class="el" href="OgreGLSLESProgramPipeline_8h_source.html">OgreGLSLESProgramPipeline.h</a>.</p>

</div>
</div>
<a class="anchor" id="af3f80fe5f80f4a13222c5ea7719d2c6d"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::getMicrocodeFromCache" ref="af3f80fe5f80f4a13222c5ea7719d2c6d" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#af3f80fe5f80f4a13222c5ea7719d2c6d">Ogre::GLSLESProgramCommon::getMicrocodeFromCache</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the the binary data of a program from the microcode cache. </p>

</div>
</div>
<a class="anchor" id="a5d44237c5eb6e0d27f26c4ddae941992"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::getVertexProgram" ref="a5d44237c5eb6e0d27f26c4ddae941992" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GLSLESGpuProgram.html">GLSLESGpuProgram</a>* <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#a5d44237c5eb6e0d27f26c4ddae941992">Ogre::GLSLESProgramCommon::getVertexProgram</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreGLSLESProgramCommon_8h_source.html#l00143">143</a> of file <a class="el" href="OgreGLSLESProgramCommon_8h_source.html">OgreGLSLESProgramCommon.h</a>.</p>

</div>
</div>
<a class="anchor" id="a073a89b01f4272838b0fd55a0c7695b6"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::isAttributeValid" ref="a073a89b01f4272838b0fd55a0c7695b6" args="(VertexElementSemantic semantic, uint index)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#a073a89b01f4272838b0fd55a0c7695b6">Ogre::GLSLESProgramCommon::isAttributeValid</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d">VertexElementSemantic</a>&#160;</td>
          <td class="paramname"><em>semantic</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a>&#160;</td>
          <td class="paramname"><em>index</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Is a non-standard attribute bound in the linked code? </p>

</div>
</div>
<a class="anchor" id="a8cf3062bfbf1c8a7ba0c2ff3350cbfae"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::isSkeletalAnimationIncluded" ref="a8cf3062bfbf1c8a7ba0c2ff3350cbfae" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#a8cf3062bfbf1c8a7ba0c2ff3350cbfae">Ogre::GLSLESProgramCommon::isSkeletalAnimationIncluded</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns whether the linked program includes the required instructions to perform skeletal animation. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>If this returns true, OGRE will not blend the geometry according to skeletal animation, it will expect the vertex program to do it. </dd></dl>

<p>Definition at line <a class="el" href="OgreGLSLESProgramCommon_8h_source.html#l00136">136</a> of file <a class="el" href="OgreGLSLESProgramCommon_8h_source.html">OgreGLSLESProgramCommon.h</a>.</p>

</div>
</div>
<a class="anchor" id="a67993567b5302107ef1730147aa4071b"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::setSkeletalAnimationIncluded" ref="a67993567b5302107ef1730147aa4071b" args="(bool included)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#a67993567b5302107ef1730147aa4071b">Ogre::GLSLESProgramCommon::setSkeletalAnimationIncluded</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>included</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets whether the linked program includes the required instructions to perform skeletal animation. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>If this is set to true, OGRE will not blend the geometry according to skeletal animation, it will expect the vertex program to do it. </dd></dl>

<p>Definition at line <a class="el" href="OgreGLSLESProgramCommon_8h_source.html#l00128">128</a> of file <a class="el" href="OgreGLSLESProgramCommon_8h_source.html">OgreGLSLESProgramCommon.h</a>.</p>

</div>
</div>
<a class="anchor" id="aec8e2b4cc8d39950abeaec2a5187fd51"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::updatePassIterationUniforms" ref="aec8e2b4cc8d39950abeaec2a5187fd51" args="(GpuProgramParametersSharedPtr params)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#aec8e2b4cc8d39950abeaec2a5187fd51">Ogre::GLSLESProgramPipeline::updatePassIterationUniforms</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__Materials.html#gaebab7cecf3f3ae81a1fbfa08ab36f2b5">GpuProgramParametersSharedPtr</a>&#160;</td>
          <td class="paramname"><em>params</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Updates program pipeline object uniforms using data from pass iteration <a class="el" href="classOgre_1_1GpuProgramParameters.html" title="Collects together the program parameters used for a GpuProgram.">GpuProgramParameters</a>. </p>
<p>normally called by GLSLESGpuProgram::bindMultiPassParameters() just before multi pass rendering occurs. </p>

<p>Implements <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#a367c5bc5ea59794c74777733710187d9">Ogre::GLSLESProgramCommon</a>.</p>

</div>
</div>
<a class="anchor" id="aea14577f15c1ef4d81921d0455983b43"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::updateUniforms" ref="aea14577f15c1ef4d81921d0455983b43" args="(GpuProgramParametersSharedPtr params, uint16 mask, GpuProgramType fromProgType)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#aea14577f15c1ef4d81921d0455983b43">Ogre::GLSLESProgramPipeline::updateUniforms</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__Materials.html#gaebab7cecf3f3ae81a1fbfa08ab36f2b5">GpuProgramParametersSharedPtr</a>&#160;</td>
          <td class="paramname"><em>params</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>&#160;</td>
          <td class="paramname"><em>mask</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a>&#160;</td>
          <td class="paramname"><em>fromProgType</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Updates program pipeline object uniforms using data from <a class="el" href="classOgre_1_1GpuProgramParameters.html" title="Collects together the program parameters used for a GpuProgram.">GpuProgramParameters</a>. </p>
<p>normally called by GLSLESGpuProgram::bindParameters() just before rendering occurs. </p>

<p>Implements <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#a0cf80ec9cfc0875f62c29317a5e96d3f">Ogre::GLSLESProgramCommon</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="afefa1d74fe3ba0d79068e0fae9dd3392"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::mCustomAttributesIndexes" ref="afefa1d74fe3ba0d79068e0fae9dd3392" args="[VES_COUNT][OGRE_MAX_TEXTURE_COORD_SETS]" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">GLint <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#afefa1d74fe3ba0d79068e0fae9dd3392">Ogre::GLSLESProgramCommon::mCustomAttributesIndexes</a>[<a class="el" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00da6f167783a26ed5d1c146fbeae995af0b">VES_COUNT</a>][<a class="el" href="OgreConfig_8h.html#a73f03c4000193e826a1489b02ea50309">OGRE_MAX_TEXTURE_COORD_SETS</a>]<code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>An array to hold the attributes indexes. </p>

<p>Definition at line <a class="el" href="OgreGLSLESProgramCommon_8h_source.html#l00083">83</a> of file <a class="el" href="OgreGLSLESProgramCommon_8h_source.html">OgreGLSLESProgramCommon.h</a>.</p>

</div>
</div>
<a class="anchor" id="aef417ccb07b8bad6b898ac41f54c289e"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::mFragmentProgram" ref="aef417ccb07b8bad6b898ac41f54c289e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GLSLESGpuProgram.html">GLSLESGpuProgram</a>* <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#aef417ccb07b8bad6b898ac41f54c289e">Ogre::GLSLESProgramCommon::mFragmentProgram</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Linked fragment program. </p>

<p>Definition at line <a class="el" href="OgreGLSLESProgramCommon_8h_source.html#l00066">66</a> of file <a class="el" href="OgreGLSLESProgramCommon_8h_source.html">OgreGLSLESProgramCommon.h</a>.</p>

</div>
</div>
<a class="anchor" id="a32fa510f466594b7bd69de3af522f793"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::mGLProgramHandle" ref="a32fa510f466594b7bd69de3af522f793" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">GLuint <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#a32fa510f466594b7bd69de3af522f793">Ogre::GLSLESProgramCommon::mGLProgramHandle</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>GL handle for the program object. </p>

<p>Definition at line <a class="el" href="OgreGLSLESProgramCommon_8h_source.html#l00070">70</a> of file <a class="el" href="OgreGLSLESProgramCommon_8h_source.html">OgreGLSLESProgramCommon.h</a>.</p>

</div>
</div>
<a class="anchor" id="aa572255a6a259344816485f9a430ef5b"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::mGLProgramPipelineHandle" ref="aa572255a6a259344816485f9a430ef5b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">GLuint <a class="el" href="classOgre_1_1GLSLESProgramPipeline.html#aa572255a6a259344816485f9a430ef5b">Ogre::GLSLESProgramPipeline::mGLProgramPipelineHandle</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>GL handle for pipeline object. </p>

<p>Definition at line <a class="el" href="OgreGLSLESProgramPipeline_8h_source.html#l00089">89</a> of file <a class="el" href="OgreGLSLESProgramPipeline_8h_source.html">OgreGLSLESProgramPipeline.h</a>.</p>

</div>
</div>
<a class="anchor" id="afb171f98bf9599ea856e1864e26de6ea"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::mGLUniformReferences" ref="afb171f98bf9599ea856e1864e26de6ea" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#a24aca8d208dcf62fbe3bee9e759ac73d">GLUniformReferenceList</a> <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#afb171f98bf9599ea856e1864e26de6ea">Ogre::GLSLESProgramCommon::mGLUniformReferences</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Container of uniform references that are active in the program object. </p>

<p>Definition at line <a class="el" href="OgreGLSLESProgramCommon_8h_source.html#l00061">61</a> of file <a class="el" href="OgreGLSLESProgramCommon_8h_source.html">OgreGLSLESProgramCommon.h</a>.</p>

</div>
</div>
<a class="anchor" id="aa4613eadde3f6f512a89e991888ccf04"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::mLinked" ref="aa4613eadde3f6f512a89e991888ccf04" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">GLint <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#aa4613eadde3f6f512a89e991888ccf04">Ogre::GLSLESProgramCommon::mLinked</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Flag indicating that the program or pipeline object has been successfully linked. </p>

<p>Definition at line <a class="el" href="OgreGLSLESProgramCommon_8h_source.html#l00072">72</a> of file <a class="el" href="OgreGLSLESProgramCommon_8h_source.html">OgreGLSLESProgramCommon.h</a>.</p>

</div>
</div>
<a class="anchor" id="ae517ad6821a32dc8ad80bbae8bc12d71"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::mSemanticTypeMap" ref="ae517ad6821a32dc8ad80bbae8bc12d71" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GLSLESProgramCommon.html#afd8df837c19c089dd8d3de4d79195dba">SemanticToStringMap</a> <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#ae517ad6821a32dc8ad80bbae8bc12d71">Ogre::GLSLESProgramCommon::mSemanticTypeMap</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreGLSLESProgramCommon_8h_source.html#l00098">98</a> of file <a class="el" href="OgreGLSLESProgramCommon_8h_source.html">OgreGLSLESProgramCommon.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4f7674420fd6fd2003a8d38260b2dd4e"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::mSkeletalAnimation" ref="a4f7674420fd6fd2003a8d38260b2dd4e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#a4f7674420fd6fd2003a8d38260b2dd4e">Ogre::GLSLESProgramCommon::mSkeletalAnimation</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Flag indicating skeletal animation is being performed. </p>

<p>Definition at line <a class="el" href="OgreGLSLESProgramCommon_8h_source.html#l00076">76</a> of file <a class="el" href="OgreGLSLESProgramCommon_8h_source.html">OgreGLSLESProgramCommon.h</a>.</p>

</div>
</div>
<a class="anchor" id="a2e72c24016de1d9a5a361cc415094a56"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::mTriedToLinkAndFailed" ref="a2e72c24016de1d9a5a361cc415094a56" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#a2e72c24016de1d9a5a361cc415094a56">Ogre::GLSLESProgramCommon::mTriedToLinkAndFailed</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Flag indicating that the program or pipeline object has tried to link and failed. </p>

<p>Definition at line <a class="el" href="OgreGLSLESProgramCommon_8h_source.html#l00074">74</a> of file <a class="el" href="OgreGLSLESProgramCommon_8h_source.html">OgreGLSLESProgramCommon.h</a>.</p>

</div>
</div>
<a class="anchor" id="a47b1e5061bc550867335014ba3188c89"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::mUniformRefsBuilt" ref="a47b1e5061bc550867335014ba3188c89" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#a47b1e5061bc550867335014ba3188c89">Ogre::GLSLESProgramCommon::mUniformRefsBuilt</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Flag to indicate that uniform references have already been built. </p>

<p>Definition at line <a class="el" href="OgreGLSLESProgramCommon_8h_source.html#l00068">68</a> of file <a class="el" href="OgreGLSLESProgramCommon_8h_source.html">OgreGLSLESProgramCommon.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac5cf7946fde74b57c5fceb2c24a6d60a"></a><!-- doxytag: member="Ogre::GLSLESProgramPipeline::mVertexProgram" ref="ac5cf7946fde74b57c5fceb2c24a6d60a" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GLSLESGpuProgram.html">GLSLESGpuProgram</a>* <a class="el" href="classOgre_1_1GLSLESProgramCommon.html#ac5cf7946fde74b57c5fceb2c24a6d60a">Ogre::GLSLESProgramCommon::mVertexProgram</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Linked vertex program. </p>

<p>Definition at line <a class="el" href="OgreGLSLESProgramCommon_8h_source.html#l00064">64</a> of file <a class="el" href="OgreGLSLESProgramCommon_8h_source.html">OgreGLSLESProgramCommon.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreGLSLESProgramPipeline_8h_source.html">OgreGLSLESProgramPipeline.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:31
</p>
</body>
</html>
